	.dbfile C:\iccv7arm\MICROB~2\MicroBolt_AtoD.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; AtoDvalueChan1 -> R9
; AtoDvalueChan0 -> R8
;          Count -> R7
;          Delay -> R6
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBolt_AtoD.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 9/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
;  
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBolt_AtoD.h"
; #include "SerialDebugger.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 39
;   unsigned int Delay = 0;
	mov R6,#0
	.dbline 40
;   unsigned char Count = 0;
	mov R7,#0
	.dbline 43
;   unsigned short AtoDvalueChan0, AtoDvalueChan1;
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 50
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 51
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 53
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 60
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+8
	ldr R5,LIT_main+12
	str R4,[R5,#0]
	.dbline 61
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 62
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 69
; 
; /*
; |-------------------------
; | Config PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+24
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 70
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+28
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 71
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 72
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 79
; 
; /*
; |-------------------------
; | Config PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 86
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00005505;                       // Setup with ICCARM App builder - MicroBolt_AtoD.bcf (UART0 and SPI pins)   
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 87
;   PCB_PINSEL1=0x55400000;                       //                                                    (Secondary JTAG pins) 
	ldr R4,LIT_main+48
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 89
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+56
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 90
;   GPIO_IODIR |= A_TO_D_CHIP_SELECT;             // Setup A to D chip select - P0.16 
	ldr R4,LIT_main+56
	ldr R5,[R4,#0]
	orr R5,R5,#65536
	str R5,[R4,#0]
	.dbline 92
; 
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R4,#0
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 94
; 
; 	GPIO_IOSET = A_TO_D_CHIP_SELECT;              // Chip select high to start with - Disabled
	mov R4,#65536
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 101
; 
; /*
; |-------------------------
; | Config SPI (Master) 
; |-------------------------
; */
;  	SPI_SPCR=0x00000020;													// Setup edges
	mov R4,#32
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 102
;  	SPI_SPCCR=0x00000052;													// Clock frequency 170 KHz	
	mov R4,#82
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 109
; 
; /*
; |-------------------------
; | Config UART-O 
; |-------------------------
; */
;   UART0_IER = 0x00000001;	 	                   // Receive interrupts
	mov R4,#1
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 110
;   UART0_FCR = 0x00000001;	 	                   // Enable the fifos
	mov R4,#1
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 111
;   UART0_LCR = 0x00000083;	 	                   // Enable the divisor
	mov R4,#131
	ldr R5,LIT_main+84
	str R4,[R5,#0]
	.dbline 112
;   UART0_DLM = 0;				                       // Divisor latch MSB (for baud rates < 4800) 
	mov R4,#0
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 113
;   UART0_DLL = BAUD_RATE_115200;			           // Divisor latch LSB 
	mov R4,#8
	ldr R5,LIT_main+88
	str R4,[R5,#0]
	.dbline 114
;   UART0_LCR = 0x00000003;  	                   // Close it, then UART works with divisor
	mov R4,#3
	ldr R5,LIT_main+84
	str R4,[R5,#0]
	.dbline 116
; 
;   __ENABLE_INTERRUPT();                        // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	b L3
L2:
	.dbline 125
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                                      // Do this forever
;     {
	.dbline 126
;     AtoDvalueChan0 = ReadAtoD(CHANNEL_0);                       // Read A to D channel 0
	mov R0,#0
	bl _ReadAtoD
	mov R4,R0
	mov R8,R4
	.dbline 127
;     AtoDvalueChan1 = ReadAtoD(CHANNEL_1);                       // Read A to D channel 1
	mov R0,#1
	bl _ReadAtoD
	mov R4,R0
	mov R9,R4
	.dbline 129
;                                                   
;     SerialDebug(1,"MCP3202 Chan-0 value: %d", AtoDvalueChan0);  // Output string to MicroBolt Serial Debugger Debug window 1
	mov R0,#1
	ldr R1,LIT_main+92
	mov R2,R8,lsl #16
	mov R2,R2,lsr #16
	bl _SerialDebug
	.dbline 130
;     SerialDebug(2,"MCP3202 Chan-1 value: %d", AtoDvalueChan1);  // Output string to MicroBolt Serial Debugger Debug window 2  
	mov R0,#2
	ldr R1,LIT_main+96
	mov R2,R9,lsl #16
	mov R2,R2,lsr #16
	bl _SerialDebug
	.dbline 132
	mov R6,#0
	b L10
L7:
	.dbline 132
L8:
	.dbline 132
	add R6,R6,#1
L10:
	.dbline 132
;        
;     for (Delay = 0; Delay < 870000; Delay++);                   // Delay for 100 mS
	ldr R4,LIT_main+100
	cmp R6,R4
	blo L7
	.dbline 134
; 
;     Count++;                                                    // Now simply blink the serial debugger LED
	and R4,R7,#255
	add R4,R4,#1
	mov R7,R4
	.dbline 135
;     if (Count == 10)
	and R4,R7,#255
	cmp R4,#10
	bne L11
	.dbline 136
;       {
	.dbline 137
;       SerialDebugLed(LED_ON);
	mov R0,#1
	bl _SerialDebugLed
	.dbline 138
;       GPIO_IOSET = MICROBOLT_LED;
	mov R4,#4194304
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 139
;       }
	b L12
L11:
	.dbline 141
;     else
;     if (Count == 20)
	and R4,R7,#255
	cmp R4,#20
	bne L13
	.dbline 142
;       {
	.dbline 143
;       Count = 0;
	mov R7,#0
	.dbline 144
;       SerialDebugLed(LED_OFF);
	mov R0,#0
	bl _SerialDebugLed
	.dbline 145
;       GPIO_IOCLR = MICROBOLT_LED;
	mov R4,#4194304
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 146
;       }
L13:
L12:
	.dbline 147
L3:
	.dbline 124
	b L2
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD 21765
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536707068
	DCD -536739840
	DCD -536739828
	DCD -536821756
	DCD -536821752
	DCD -536821748
	DCD -536821760
	DCD L5
	DCD L6
	DCD 870000
	.dbsym r AtoDvalueChan1 9 s
	.dbsym r AtoDvalueChan0 8 s
	.dbsym r Count 7 c
	.dbsym r Delay 6 i
	.dbend
	EXPORT _ReadAtoD
	.dbfunc e ReadAtoD _ReadAtoD fs
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; AnalogToDigitalLsbValue -> R6
; AnalogToDigital12bitValue -> R7
; AnalogToDigitalMsbValue -> R8
; AtoDchannelNumber -> R6
_ReadAtoD:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R7,R8,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 161
;     }
; }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   ReadAtoD
; |     Inputs          :   None
; |     Outputs         :   Analog value from the A to D
; |     Purpose         :   Read A to D values from MCP3202
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; unsigned short ReadAtoD(unsigned char AtoDchannelNumber)
;   {
	.dbline 166
; 	unsigned char AnalogToDigitalMsbValue;
; 	unsigned char AnalogToDigitalLsbValue;
; 	unsigned short AnalogToDigital12bitValue;
; 
; 	GPIO_IOCLR = A_TO_D_CHIP_SELECT;                                  // Chip select low - Enable
	mov R4,#65536
	ldr R5,LIT_ReadAtoD+0
	str R4,[R5,#0]
	.dbline 167
; 	Delay10uS();																											// Setup time
	bl _Delay10uS
	.dbline 169
; 
; 	SPI_SPDR = A_TO_D_START_SINGLE;                                   // Send out first byte to A to D
	mov R4,#1
	ldr R5,LIT_ReadAtoD+4
	str R4,[R5,#0]
L16:
	.dbline 170
L17:
	.dbline 170
; 	while(!(SPI_SPSR & SPIF));                                        // Wait for completion
	ldr R4,LIT_ReadAtoD+8
	ldr R4,[R4,#0]
	tst R4,#128
	beq L16
	.dbline 172
; 
;   if (AtoDchannelNumber == CHANNEL_0)                               // Send out 2nd byte, data depends on channel number
	ands R4,R6,#255
	bne L19
	.dbline 173
;       {
	.dbline 174
; 	    SPI_SPDR = A_TO_D_CHANNEL_0;
	mov R4,#160
	ldr R5,LIT_ReadAtoD+4
	str R4,[R5,#0]
	.dbline 175
;       }
	b L22
L19:
	.dbline 177
;   else
;       {
	.dbline 178
; 	    SPI_SPDR = A_TO_D_CHANNEL_1;
	mov R4,#224
	ldr R5,LIT_ReadAtoD+4
	str R4,[R5,#0]
	.dbline 179
;       }    
L21:
	.dbline 180
L22:
	.dbline 180
; 	while(!(SPI_SPSR & SPIF));                                        // Wait for completion
	ldr R4,LIT_ReadAtoD+8
	ldr R4,[R4,#0]
	tst R4,#128
	beq L21
	.dbline 182
; 
; 	AnalogToDigitalMsbValue =  SPI_SPDR;                              // Got the first desired byte (MSB) of A to D data, now store it
	ldr R4,LIT_ReadAtoD+4
	ldr R4,[R4,#0]
	mov R8,R4
	.dbline 184
; 
; 	SPI_SPDR = A_TO_D_NULL_WAIT_FOR_DATA;                             // Send out 3rd byte of data so as to get the second A to D byte
	mov R4,#0
	ldr R5,LIT_ReadAtoD+4
	str R4,[R5,#0]
L24:
	.dbline 185
L25:
	.dbline 185
; 	while(!(SPI_SPSR & SPIF));                                        // Wait for completion
	ldr R4,LIT_ReadAtoD+8
	ldr R4,[R4,#0]
	tst R4,#128
	beq L24
	.dbline 187
; 
; 	AnalogToDigitalLsbValue =  SPI_SPDR;                              // Got the second byte (LSB) of A to D data, now store it
	ldr R4,LIT_ReadAtoD+4
	ldr R4,[R4,#0]
	mov R6,R4
	.dbline 189
; 
; 	Delay10uS();																										  // Hold time
	bl _Delay10uS
	.dbline 190
; 	GPIO_IOSET = A_TO_D_CHIP_SELECT;                                  // Chip select high - Disable
	mov R4,#65536
	ldr R5,LIT_ReadAtoD+12
	str R4,[R5,#0]
	.dbline 194
;                                                                 
;                                                                     // Now create 12 bit A to D value...
; 
; 	AnalogToDigitalMsbValue = AnalogToDigitalMsbValue & 0x0F;																						// Drop top 4 bits from MSB for 12 bit value
	and R4,R8,#255
	and R4,R4,#15
	mov R8,R4
	.dbline 195
; 	AnalogToDigital12bitValue = (unsigned short)AnalogToDigitalMsbValue << 8;                           // Store MSB by shifting up 8
	and R4,R8,#255
	mov R4,R4,lsl #16
	mov R4,R4,lsr #16
	mov R4,R4,lsl #8
	mov R7,R4
	.dbline 196
; 	AnalogToDigital12bitValue = AnalogToDigital12bitValue | (unsigned short) AnalogToDigitalLsbValue;		// OR in the LSB to get the final value
	and R4,R6,#255
	mov R4,R4,lsl #16
	mov R4,R4,lsr #16
	mov R5,R7,lsl #16
	mov R5,R5,lsr #16
	orr R4,R5,R4
	mov R7,R4
	.dbline 198
; 
; 	return(AnalogToDigital12bitValue);                                // 12 bit A to D value read from MCP3202, return it
	mov R0,R7,lsl #16
	mov R0,R0,lsr #16
	.dbline -2
L15:
	ldmfd R11,{R4,R5,R6,R7,R8,R11,SP,PC}
	.dbline 0 ; func end
LIT_ReadAtoD:
	DCD -536707060
	DCD -536739832
	DCD -536739836
	DCD -536707068
	.dbsym r AnalogToDigitalLsbValue 6 c
	.dbsym r AnalogToDigital12bitValue 7 s
	.dbsym r AnalogToDigitalMsbValue 8 c
	.dbsym r AtoDchannelNumber 6 c
	.dbend
	EXPORT _Delay10uS
	.dbfunc e Delay10uS _Delay10uS fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Delay -> R11,-4
_Delay10uS:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 212
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay10uS
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 10 uS when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void Delay10uS(void)   
;   {
	.dbline 215
	mov R0,#0
	str R0,[R11,#-4]
	b L31
L28:
	.dbline 215
L29:
	.dbline 215
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L31:
	.dbline 215
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 35; Delay++);          // Delay for 10 uS 
	ldr R0,[R11,#-4]
	cmp R0,#35
	blo L28
	.dbline -2
L27:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbsym l Delay -4 i
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 230
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; void pll_isr(void)
;   {
	.dbline 231
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 232
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 233
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 234
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 235
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L32:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	AREA	"C$$code", CODE, READONLY
L6:
	DCB "MCP3202 Chan-1 value: %d", 0
L5:
	DCB "MCP3202 Chan-0 value: %d", 0
	END
